#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include        "tof77.h"

#include "compilerApi.h"

extern void forall_do(SgStatement *s);

void trans_do_while(SgStatement *s)
{
	int org_numberOfChildren=s->numberOfChildrenList1();
	SgStatement * * children=new SgStatement * [org_numberOfChildren];

	int i;

	for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i);

	SgExpression *cond= ((SgWhileStmt *)s)->conditional()->copyPtr();
	SgExpression *condition = new SgExpression (NOT_OP, cond , NULL , NULL);
	SgExitStmt *exit_stmt = new SgExitStmt();
	SgLogIfStmt *if_stmt = new SgLogIfStmt(*condition , *exit_stmt);
	if_stmt->thebif->variant=LOGIF_STMT;

	children[0]->insertStmtBefore(*if_stmt , *s );

	// empty do loop
	s->thebif->variant = FOR_NODE;
	BIF_LL1(s->thebif)=LLNULL;
/*
	SgLabel *do_label=((SgForStmt *)s)->endOfLoop();
	if ( !do_label )
	{
		SgStatement *hedr_stmt = s->getScopeForDeclare();
		do_label= new SgLabel(*hedr_stmt);
	}
	
	SgExpression *condition = ((SgWhileStmt *)s)->conditional()->copyPtr();

	SgStatement *body = children[0]->copyPtr();
	SgIfStmt *if_stmt=new SgIfStmt(*condition,*body );
	if_stmt->setLabel(do_label);
	
	for(i=1;i<org_numberOfChildren;i++)
	{
		if ( children[i]->variant() == CONTROL_END ||
		     children[i]->variant() == ENDDO_STMT )
			break;
		SgStatement *stmt 
		body->insertStmtAfter(*(children[i])->copyPtr() , *if_stmt);
	}
	SgGotoStmt *goto_stmt = new SgGotoStmt(*do_label);
	s->insertStmtAfter(*goto_stmt , *s->controlParent() );
	s->insertStmtAfter(*if_stmt , *s->controlParent() );

	s->deleteStmt();
*/

        delete [] children;
}

void analyse4(SgStatement * s)
{
  switch(s->variant())
  {
    case GLOBAL:
      {
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i);
         for(i=0;i<org_numberOfChildren;i++)
             analyse4(children[i]);

        delete [] children;

        break;
      };

   case PROG_HEDR:
      { 
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i); 

         in_main_program=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse4(children[i]);

         delete [] children;

         in_main_program=off;
  
         break;
       };

  case INTERFACE_STMT:
    {
      SgProcHedrStmt * prochedr = (SgProcHedrStmt *)s;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
	analyse4(children[i]);
      
      delete [] children;

      break;
    }

   case PROC_HEDR:
      {
        SgProcHedrStmt * prochedr=(SgProcHedrStmt *)s;
        int org_numberOfChildren=s->numberOfChildrenList1();
        SgStatement * * children=new SgStatement * [org_numberOfChildren];

        int i;

        for(i=0;i<org_numberOfChildren;i++)
            children[i]=s->childList1(i);

        in_procedure=on;

        for(i=0;i<org_numberOfChildren;i++)
             analyse4(children[i]);
     
        delete [] children;

        in_procedure=off;

        break;
      };

    case FUNC_HEDR:
      {
         SgFuncHedrStmt * prochedr=(SgFuncHedrStmt *)s;
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
              children[i]=s->childList1(i);

         in_function=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse4(children[i]);

         delete [] children;

         in_function=off;

         break;
      };  
  case FOR_NODE:
  case LOGIF_NODE:
  case ELSEIF_NODE:
  case LOGIF_STMT:
  case SWITCH_NODE:
  case CASE_NODE:
    {
      int org_numberOfChildren1=s->numberOfChildrenList1();

      SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];

      int org_numberOfChildren2=s->numberOfChildrenList2();

      SgStatement * * children2 = new SgStatement * [org_numberOfChildren2];

      int i;

      for (i=0; i<org_numberOfChildren1; i++)
	children1[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren1; i++)
	analyse4(children1[i]);
      
      delete [] children1;

      for (i=0; i<org_numberOfChildren2; i++)
	children2[i]=s->childList2(i);			

      for (i=0; i<org_numberOfChildren2; i++)
	analyse4(children2[i]);
      
      delete [] children2;

      break;

    }
    case DO_WHILE_NODE:
      {
 	trans_do_while(s);
         break;
      };
  }
 
}

